global mov_all_bytes_asm
global nop_all_bytes_asm
global nop_1x3_all_bytes_asm
global nop_1x9_all_bytes_asm
global inc_all_bytes_asm
global dec_all_bytes_asm

mov_all_bytes_asm:
	xor rax, rax

	.loop:
		mov BYTE [rdi + rax * 1], al
		inc rax
		cmp rsi, rax
		jne .loop

	ret

nop_all_bytes_asm:
	xor rax, rax

	.loop:
		db 0x0f, 0x1f, 0x00
		inc rax
		cmp rdi, rax
		jne .loop

	ret

nop_1x3_all_bytes_asm:
	xor rax, rax

	.loop:
		nop
		nop
		nop
		inc rax
		cmp rdi, rax
		jne .loop

	ret

nop_1x9_all_bytes_asm:
	xor rax, rax

	.loop:
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		inc rax
		cmp rdi, rax
		jne .loop

	ret

inc_all_bytes_asm:
	xor rax, rax

	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

dec_all_bytes_asm:
	.loop:
		dec rdi
		jnz .loop

	ret
